/**
 * A utility class in case you
 * write a stand-alone CG and need
 * to write the diagnostics
 * at each iteration
 * @author: Joseph Jennings
 * @version: 2017.05.40
 */

#ifndef CGHELP_H_
#define CGHELP_H_

#include <map>
#include "my_vector.h"

class cghelp {
  public:
    cghelp(std::string modtag, std::string grdtag, std::string oftag, std::string ddtag);
    void set_resout(std::string tag);
    void set_mrsout(std::string tag);
    void set_grdout(std::string tag);
    void set_grd1out(std::string tag);
    void set_grd2out(std::string tag);
    void set_modout(std::string tag);
    void set_mod1out(std::string tag);
    void set_mod2out(std::string tag);
    void set_rdnout(std::string tag);
    void set_rmnout(std::string tag);
    void set_rtnout(std::string tag);
    void set_gnout(std::string tag);
    void set_ddout(std::string tag);
    void set_ofout(std::string tag);
    void output(my_vector *res, my_vector *ddat, my_vector *grad, my_vector *mod, double obj);
    ~cghelp(){};

  private:
    std::map<std::string,std::string> _fouts;
    std::vector<float> _one;
    int _counter = 0;
};

#endif /* CGHELP_H_ */
