/**
 * Tapers the gradient during a Waveform
 * Inversion process with an exponential
 * function
 * @author: Joseph Jennings
 * @version: 2017.05.02
 */

#ifndef GRAD_TAPER_H_
#define GRAD_TAPER_H_

#include "my_operator.h"
#include "hypercube_float.h"

class grad_taper : public my_operator {
  public:
    grad_taper(){};
    grad_taper(axis taxis, float z1, float z2);
    bool forward(bool add, my_vector *mod, my_vector *dat);
    bool adjoint(bool add, my_vector *mod, my_vector *dat);
    ~grad_taper(){
      delete _tapfunc;
    }

  private:
    std::vector<axis> _taxes;
    hypercube_float *_tapfunc;

};

#endif /* GRAD_TAPER_H_ */
