/*
 * pefsignoi3d.cpp
 *
 *  Created on: Apr 29, 2017
 *      Author: joe
 */

#include "pefsignoi3d.h"
#include "identity.h"

pefsignoi3d::pefsignoi3d(hypercube_float *dat, lv_conv3dm* spef, lv_conv3dm* npef) {
  /* Creation of blending operator */
  identity *iop1 = new identity();
  identity *iop2 = new identity();
  iop1->set_domain(dat); iop1->set_range(dat);
  iop2->set_domain(dat); iop2->set_range(dat);
  _gam = new row_op(iop1,iop2);

  /* Diagonal PEF operator */
  spef->set_domain(dat); spef->set_range(dat);
  npef->set_domain(dat); npef->set_range(dat);
  _pefs = new diag_op(npef,spef);

  /* Build total operator */
  _A = new col_op(_gam,_pefs);
}


bool pefsignoi3d::forward(bool add, my_vector *mod, my_vector *dat) {

  if(!add) {
    if(!dat) {
      seperr("pefsignoi3d: cannot operate on null data vector.\n");
    }
    dat->zero();
    _A->forward(false,mod,dat);
  } else {
    _A->forward(true,mod,dat);
  }

  return true;
}

bool pefsignoi3d::adjoint(bool add, my_vector *mod, my_vector *dat) {

  _A->adjoint(false,mod,dat);
  return true;
}
