Program alicomb

  use sep
  use mem_mod
  use laplace_mod
  use comb_mod

  implicit none

  integer                           :: n1, n2
  integer                           :: bc1,bc2,bc3,bc4
  real                              :: d1, d2, dtu2
  real, dimension(:,:), allocatable :: modl, dat
  real, dimension(:,:), allocatable :: wt,vwt,vel,veldt2
  logical                           :: adj

  call sep_init()

  call hetch("n1","d",n1)
  call hetch("d1","f",d1)
  call hetch("n2","d",n2)
  call hetch("d2","f",d2)

  call from_param("bc1",bc1,100)
  call from_param("bc2",bc2,100)
  call from_param("bc3",bc3,100)
  call from_param("bc4",bc4,100)

  call mem_alloc2d(wt,n1,n2)
  call mem_alloc2d(vwt,n1,n2)
  call mem_alloc2d(vel,n1,n2)
  call mem_alloc2d(veldt2,n1,n2)
  call mem_alloc2d(modl,n1,n2)
  call mem_alloc2d(dat ,n1,n2)

  call getch("adj","d",adj)

  if(adj) then
    call sreed("in",dat,n1*n2*4)
  else 
    call sreed("in",modl,n1*n2*4)
  endif

  dtu2 = 0.001*0.001
  vel = 3000
  veldt2 = vel*vel*dtu2
  wt = 0.01
  vwt = 0.1
  call comb_init(n1, n2, bc1, bc2, bc3, bc4, d1, d2, veldt2, vwt, wt)
  call comb_op2(adj,.false.,modl,dat)

  call putch("n1","d",n1); call putch("d1","f",d1)
  call putch("n2","d",n2); call putch("d2","f",d2)

  if(adj) then
    call srite("out",modl,n1*n2*4)
  else
    call srite("out",dat,n1*n2*4)
  endif

end program
