Program alicrtdata

  use sep
  use mem_mod
  use lint_mod

  implicit none

  integer                             :: nx,nz,nt,ntw,nrx
  integer                             :: wfldj
  integer                             :: irec
  real                                :: dt,dtw,dx,dz
  real                                :: orx,drx,rec_x,rec_z
  real, dimension(:,:,:), allocatable :: wfldf, wfldc
  real, dimension(:,:)  , allocatable :: dat
  logical                             :: adj

  call sep_init()

  call from_param("adj",adj,.false.)
  call from_param("wfldj",wfldj,4)
  if(adj) then
    call from_history("n1",nz,300)
    call from_history("n2",nx,300)
    call from_history("n3",ntw,800)
  else
    call from_history("n1",nt,200)
    call from_history("d1",dt,0.004)
    call from_history("n2",nrx,200)
    call from_history("o2",orx,52.0)
    call from_history("d2",drx,1.0)
  endif

  ! Command line parameters
  if(adj) then
    call from_param("nt",nt,200)
    call from_param("dt",dt,0.004)
    call from_param("nrx",nrx,200)
    call from_param("orx",orx,52.0)
    call from_param("drx",drx,1.0)
    call from_param("recz",rec_z,151.0)
  else
    call from_param("nx",nx,300)
    call from_param("dx",dx,10.0)
    call from_param("nz",nz,300)
    call from_param("dz",dz,10.0)
    call from_param("ntw",ntw,800)
    call from_param("dtw",dtw,0.001)
    call from_param("recz",rec_z,151.0)
  endif

  call mem_alloc3d(wfldf,nz,nx,ntw)
  call mem_alloc3d(wfldc,nz,nx,nt)
  call mem_alloc2d(dat,nrx,nt)

  if(adj) then
    call sreed("in",wfldf,nz*nx*ntw*4)
  else
    call sreed("in",dat,nrx*nt*4)
  endif

  call lint_init(nz,nx,nt,wfldj)

  if(adj) then
    call lint_op2(.true.,.false.,wfldc,wfldf)
    do irec=1,nrx
      rec_x = (irec-1)*drx + orx
      dat(:,irec) = dat(:,irec) + wfldc(rec_z,rec_x,:)
    end do
  else 
    wfldc = 0.
    do irec=1,nrx
      rec_x = (irec-1)*drx + orx
      wfldc(rec_z,rec_x,:) = wfldc(rec_z,rec_x,:) + dat(:,irec)
    enddo
    call lint_op2(.false.,.false.,wfldc,wfldf)
  endif

  if(adj) then
    call putch("n1","d",nt);  call putch("o1","f",0.0); call putch("d1","f",dt)
    call putch("n2","d",nrx); call putch("o2","f",orx); call putch("d2","f",drx)
    call putch("n3","d",1);   call putch("o3","f",0.0); call putch("d3","f",1.0)
    call srite("out",dat,nrx*nt*4)
  else
    call putch("n1","d",nz);  call putch("o1","f",0.0); call putch("d1","f",dz)
    call putch("n2","d",nx); call putch("o2","f",0.0); call putch("d2","f",dx)
    call putch("n3","d",nt);   call putch("o3","f",0.0); call putch("d3","f",dt)
    call srite("out",wfldc,nz*nx*nt*4)
  endif

end program
