Program alilap

  use sep
  use mem_mod
  use laplace_mod

  implicit none

  integer                           :: n1, n2
  real                              :: d1, d2
  real, dimension(:,:), allocatable :: modl, dat
  logical                           :: adj

  call sep_init()

  call hetch("n1","d",n1)
  call hetch("d1","f",d1)
  call hetch("n2","d",n2)
  call hetch("d2","f",d2)

  call mem_alloc2d(modl,n1,n2)
  call mem_alloc2d(dat ,n1,n2)

  call getch("adj","d",adj)

  if(adj) then
    call sreed("in",dat,n1*n2*4)
  else 
    call sreed("in",modl,n1*n2*4)
  endif

  call laplace_init(n1,n2,d1,d2)
  call laplace_op2(adj,.false.,modl,dat)

  call putch("n1","d",n1); call putch("d1","f",d1)
  call putch("n2","d",n2); call putch("d2","f",d2)

  if(adj) then
    call srite("out",modl,n1*n2*4)
  else
    call srite("out",dat,n1*n2*4)
  endif

end program
