/**
 * Tests the dot product
 * of the zeropadimg operator
 * @author: Joseph Jennings
 * @version: 2016.11.25
 */
#include <limits.h>
#include "gtest/gtest.h"
#include "../main/zeropadimg.h"
#include "../main/simpleplot.h"
#include "axis.h"
#include "hypercube_float.h"

class zeropadimgtest: public ::testing::Test {
  protected:
    virtual void SetUp(){
    }

    virtual void TearDown() {
    }
};

TEST_F(zeropadimgtest,dptest){
  int nx = 100; int nz = 100;
  int p = 50; int shift = p/2;
  /* Build axes */
  axis ax  = axis(nx  , 0.0, 1.0);
  axis az  = axis(nz  , 0.0, 1.0);
  axis axp = axis(nx+p, 0.0, 1.0);
  axis azp = axis(nz+p, 0.0, 1.0);
  std::vector<axis> axes, paxes;
  axes.push_back(az);   axes.push_back(ax);
  paxes.push_back(azp); paxes.push_back(axp);
  /* Build hypercubes */
  hypercube_float *m  = new hypercube_float(axes , true);
  hypercube_float *ms = new hypercube_float(axes, true);
  hypercube_float *d  = new hypercube_float(paxes , true);
  hypercube_float *ds = new hypercube_float(paxes, true);
  m->random(); d->random();
  zeropadimg zpi = zeropadimg(shift,shift,0.0);
  /* Add == false */
  zpi.forward(false, m, ds);
  float dotd = d->dot(ds);
  zpi.adjoint(false, ms, d);
  float dotm = m->dot(ms);
  EXPECT_NEAR(dotd, dotm, 0.000001);
  delete m; delete ms;
  delete d; delete ds;
}
